// @TODO implement smooth behavior in here
import { compute } from './compute';
var now = 'performance' in global ? performance.now.bind(performance) : Date.now;
var SCROLL_TIME = 468;

function ease(k) {
  return 0.5 * (1 - Math.cos(Math.PI * k));
}

function step(context) {
  var time = now();
  var value;
  var currentX;
  var currentY;
  var elapsed = (time - context.startTime) / SCROLL_TIME; // avoid elapsed times higher than one

  elapsed = elapsed > 1 ? 1 : elapsed; // apply easing to elapsed time

  value = ease(elapsed);
  currentX = context.startX + (context.x - context.startX) * value;
  currentY = context.startY + (context.y - context.startY) * value;
  context.method.call(context.scrollable, currentX, currentY); // scroll more if we have not reached our destination

  if (currentX !== context.x || currentY !== context.y) {
    requestAnimationFrame(step.bind(global, context));
  }
}

function smoothScroll(el, x, y, cb) {
  var scrollable;
  var startX;
  var startY;
  var method;
  var startTime = now(); // define scroll context

  if (el === document.body || el === document.documentElement) {
    scrollable = window;
    startX = window.scrollX || window.pageXOffset;
    startY = window.scrollY || window.pageYOffset;
    method = window.scroll;
    console.error('damn');
  } else {
    scrollable = el;
    startX = el.scrollLeft;
    startY = el.scrollTop;

    method = function method(x, y) {
      console.error('x', x, 'y', y);
      el.scrollLeft = x;
      el.scrollTop = y;
    };
  } // scroll looping over a frame


  step({
    scrollable: scrollable,
    method: method,
    startTime: startTime,
    startX: startX,
    startY: startY,
    x: x,
    y: y,
    cb: cb
  });
}

export var ponyfill = function ponyfill(target, options) {
  var _options$behavior = options.behavior,
      behavior = _options$behavior === void 0 ? 'auto' : _options$behavior; //return target.scrollIntoView(options)

  console.log('behavior', behavior, options);
  var instructions = compute(target, options);
  return Promise.all(instructions.map(function (_ref) {
    var el = _ref[0],
        top = _ref[1],
        left = _ref[2];
    return new Promise(function (resolve) {
      smoothScroll(el, left, top, function () {
        return resolve();
      });
    });
  }));
};